package jlabos;

import org.yaml.snakeyaml.Yaml;
import java.io.*;
import java.util.*;
public class Param {
   private Yaml yaml;
   private InputStream input;
   private Map<String, Object> object;
   private Map<String, Object> list1;

   public Param(String file) throws java.io.FileNotFoundException {
      this.input = new FileInputStream(new File(file));
      this.yaml = new Yaml();
      this.object = (Map<String, Object>) yaml.load(input);
   }

   public Integer getIntValue(List<String> list) throws java.io.FileNotFoundException {
      Integer toto = null;
      return getValue(toto, list);
   }

   public Double getDblValue(List<String> list) throws java.io.FileNotFoundException {
      Double toto = null;
      return getValue(toto, list);
   }

   public String getStrValue(List<String> list) throws java.io.FileNotFoundException {
      String toto = null;
      return getValue(toto, list);
   }

   private <T> T getValue(T dest, List<String> list) throws java.io.FileNotFoundException {
      Map<String, Object> list1 = object;
      for(int i = 0; i< list.size()-1; i++){
         try{
            list1 = (Map<String, Object>) list1.get(list.get(i));
         }catch(NullPointerException e){
            jlabos.Utils.pout("Error reading param: " + list.get(i));
            java.lang.System.exit(1);
         }
      }
      return(T)(list1.get(list.get(list.size()-1)));
   }
}
